﻿    // Bar Pie printer
    window.onload = function () {

        // Canvas gets same width with window
        resizeCanvas();

        // JSON loader
        var xmlhttp = new XMLHttpRequest();
        var url = "http://dev.hel.fi/stats/resources/aluesarjat_hginseutu_va_vr01_vakiluku_ika/jsonstat";

        xmlhttp.onreadystatechange = function () {
            if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
                initCharts(xmlhttp.responseText);
                updateBar(xmlhttp.responseText);
                updatePie(xmlhttp.responseText);
            }
        }
        xmlhttp.open("GET", url, true);
        xmlhttp.send();
        
        function initCharts(response) {
                
            var arr = JSON.parse(response);
            var i;
            var out = "<table>";

            document.getElementById("otsikko").innerHTML = arr.dataset.label;
                
            var AluekatekoriaIndeksi = arr.dataset.dimension.alue.category.index;
            var TempAlueKatekoriaValikko = "<select size=1>";
            for (i = 0; i < AluekatekoriaIndeksi.length; i++) {

                TempAlueKatekoriaValikko += "<option value=" + arr.dataset.dimension.alue.category.label[arr.dataset.dimension.alue.category.index[i]] + ">" + arr.dataset.dimension.alue.category.label[arr.dataset.dimension.alue.category.index[i]] + "</option>";
            }
            TempAlueKatekoriaValikko += "</select>";             
            document.getElementById("comboAlue").innerHTML = TempAlueKatekoriaValikko;

            var vuosikatekoriaIndeksi = JSON.stringify(arr.dataset.dimension.size[1]);
            var tempVuosiKatekoriaValikko = "<select size=1>";

            for (i = 0; i < vuosikatekoriaIndeksi; i++) {
                
                tempVuosiKatekoriaValikko += "<option value=vaihtoehto" + arr.dataset.dimension.vuosi.category.index[i] + ">" + arr.dataset.dimension.vuosi.category.index[i] + "</option>";
            }
            tempVuosiKatekoriaValikko += "</select>";
            document.getElementById("comboVuosi").innerHTML = tempVuosiKatekoriaValikko;

            var sukupuolikatekoriaIndeksi = arr.dataset.dimension.size[2];
            var tempsukupuoliKatekoriaValikko = "<select size=1>";

            for (i = 0; i < sukupuolikatekoriaIndeksi; i++) {

                var tempOption = arr.dataset.dimension.sukupuoli.category.label[i];
                tempsukupuoliKatekoriaValikko += "<option value=vaihtoehto" + i + ">" + tempOption + "</option>";
            }
            tempsukupuoliKatekoriaValikko += "</select>";
            document.getElementById("comboSukupuoli").innerHTML = tempsukupuoliKatekoriaValikko;

            var ikaKatekoriaIndeksi = JSON.stringify(arr.dataset.dimension.size[3]);
            var tempikaKatekoriaValikko = "<select size=1>";

            for (i = 0; i < ikaKatekoriaIndeksi; i++) {

                var tempOption = arr.dataset.dimension.ika.category.label[arr.dataset.dimension.ika.category.index[i]];
                tempikaKatekoriaValikko += "<option value=vaihtoehto" + i + ">" + tempOption + "</option>";
            }
            tempikaKatekoriaValikko += "</select>";
            document.getElementById("comboIka").innerHTML = tempikaKatekoriaValikko;

            /*for (i = 0; i < arr.length; i++) {
                document.getElementById("id02").innerHTML += JSON.stringify(arr[i]);
            }*/

            for (i = 0; i < arr.length; i++) {
                document.getElementById("id02").innerHTML = arr[i].label.toString;
                out += "<tr><td>" +
                arr[i].label +
                "</td></tr>";
            }
            out += "</table>";
        }
    };

function updateBar(response) {

    var arr = JSON.parse(response);

    var TempKaupungit = [];
    for (i = 0; i < arr.dataset.dimension.alue.category.index.length; i++) {
        TempKaupungit.push(arr.dataset.dimension.alue.category.label[arr.dataset.dimension.alue.category.index[i]]);
                
    }

    var TempKaupunginAsukasluku = [];
    for (i = 0; i < TempKaupungit.length; i++) {
        TempKaupunginAsukasluku.push(parseInt(arr.dataset.value[i * 5265]));                
    }

    document.getElementById("id01").innerHTML = TempKaupunginAsukasluku;

    var tempTest = JSON.stringify(Object.keys(arr.dataset.dimension.vuosi.category.label));

    var bar = new RGraph.Bar({

        id: 'cvs',
        data: TempKaupunginAsukasluku,
        options: {
            gutterTop: 15,
            gutterLeft: 35,
            gutterRight: 15,
            backgroundGridVlines: false,
            backgroundGridBorder: false,
            colors: ['Gradient(white:#f11:#f11)'], //, 'Gradient(white:#1cc:#1cc)', 'Gradient(white:#00f:#00f)'],
            /*tooltips: [
                'Bob on Monday: 50 sales', 'Bob on Tuesday: 60 sales', 'Bob on Wednesday: 112 sales',
                'Jamie on Monday: 65 sales', 'Jamie on Tuesday: 30 sales', 'Jamie on Wednesday: 50 sales',
                'Cynthia on Monday: 40 sales', 'Cynthia on Tuesday: 80 sales', 'Cynthia on Wednesday: 70 sales',
                'Peter on Monday: 115 sales', 'Peter on Tuesday: 100 sales', 'Peter on Wednesday: 92 sales'
             ],*/
            highlightStroke: 'rgba(0,0,0,0.1)',
            strokestyle: 'rgba(0,0,0,0)',
            shadowOffsetx: -2,
            shadowOffsety: -2,
            shadowBlur: 15,
            ymax: 6000000,
            noyaxis: true,
            ylabels: false,
            labels: TempKaupungit,
            labelsAbove: true,
            linewidth: 2,
            hmargin: 15
        }
    }).draw();
}

function updatePie(response) {

    var arr = JSON.parse(response);

    var pie = new RGraph.Pie({
        id: 'cvs',
        data: [270, 270, 164],
        options: {
            exploded: [7, 2, ],
            labels: ['Mondays sales'],
            labelsSticks: [true],
            labelsSticksColor: 'black',
            centerx: 180, // orginal 60
            centery: 135, // orginal 45
            radius: 90,  // orginal 30
            shadowBlur: 5,
            shadowOffsetx: 2,
            shadowOffsety: 2,
            shadowColor: '#aaa',
            colors: ['Gradient(white:#c11:#c11:#c11)', 'Gradient(white:#1cc:#1cc:#1cc)', 'Gradient(white:#11c:#11c:#11c)'],
            tooltips: ['Total Monday sales: 270', 'Total Tuesday sales: 270', 'Total Wednesday sales: 264'],
            tooltipsEvent: 'mousemove',
            strokestyle: 'rgba(0,0,0,0)'
        }
    }).draw();
}
        
function resizeCanvas() {

    var canvas = document.getElementById("cvs");
    var ctx = canvas.getContext("2d");

    var img = new Image();
    img.onload = function () {
        ctx.drawImage(img, 0, 0, img.width, img.height, 0, 0, canvas.width, canvas.height);
    }
}